/*---------------------------------------------------------------------------*/
/*                      INGENIOUS TECHNOLOGY CO., LTD.                       */
/*                                                                           */
/*                   TOUCH.C    For Demo Program Source                      */
/*                   TURBO C 2.0                                             */
/*                                                                           */
/*      Written on 10/01/92 by Dannes Hsieh                                  */
/*---------------------------------------------------------------------------*/

#include <graphics.h>
#include <stdlib.h>
#include <stdio.h>
#include <dos.h>
#include <alloc.h>


int  MaxX, MaxY;

int soun[3][5]={  73,  82,  87,  98, 110,
                  147, 165, 175, 196, 220,
                  262, 294, 330, 349, 392};

unsigned int Cursor[32]= /* ƹи */
   {
                  /*  Screen Mask        */
     0x3FFF,      /*  0011111111111111   */
     0x1FFF,      /*  0001111111111111   */
     0x0FFF,      /*  0000111111111111   */
     0x07FF,      /*  0000011111111111   */
     0x03FF,      /*  0000001111111111   */
     0x01FF,      /*  0000000111111111   */
     0x00FF,      /*  0000000011111111   */
     0x007F,      /*  0000000001111111   */
     0x003F,      /*  0000000000111111   */
     0x001F,      /*  0000000000011111   */
     0x01FF,      /*  0000000111111111   */
     0x10FF,      /*  0001000011111111   */
     0x30FF,      /*  0011000011111111   */
     0xF87F,      /*  1111100001111111   */
     0xF87F,      /*  1111100001111111   */
     0xFC3F,      /*  1111110000111111   */

   /*  Cursor Mask  */
     0x0000,      /*  0000000000000000   */
     0x4000,      /*  0100000000000000   */
     0x6000,      /*  0110000000000000   */
     0x7000,      /*  0111000000000000   */
     0x7800,      /*  0111100000000000   */
     0x7C00,      /*  0111110000000000   */
     0x7E00,      /*  0111111000000000   */
     0x7F00,      /*  0111111100000000   */
     0x7F80,      /*  0111111110000000   */
     0x7FC0,      /*  0111111111000000   */
     0x6C00,      /*  0110110000000000   */
     0x4600,      /*  0100011000000000   */
     0x0600,      /*  0000011000000000   */
     0x0300,      /*  0000001100000000   */
     0x0300,      /*  0000001100000000   */
     0x0000       /*  0000000000000000   */
   };

int  Reset();         /*ˬdƹO_w Ǧ^ 0 => w, 1 => w*/
void Show_Mouse();     /* ܷƹ */
void Hide_Mouse();     /* ÷ƹ */
int  Left_Pressed();   /* O_Q */
void Get_XY(int *x, int *y);       /* Ūƹ x , y y */
void Set_X_Range(int min, int max); /* ]wƹүಾ X bd */
void Set_Y_Range(int min, int max); /* ]wƹүಾ Y bd */
void Set_Graphic_Cursor(int x, int y,unsigned int far *pattern);
                                   /* ]wøϼҺAUƹХ~ */

void Graph_Init();   /* ]wøϼҦ */
void show_txt(int font, int xloc, int yloc, char *fmt, ... );
void colorbar();
void touch();
void show_color(int x1,int y1,int x2,int y2,int color);

main()
{
   int i,s;

   if(Reset() == 0)
   {
       closegraph();
       printf("Mouse not install ! ");
       exit(1);
   }

   Graph_Init();
/*
   Set_Graphic_Cursor(0, 0, Cursor);
   Set_X_Range(0, MaxX);
   Set_Y_Range(0, MaxY);
*/
   colorbar();

/* Show_Mouse();*/

   touch();

   closegraph();

}

/*-----------------------------------------------------------------*/
/*  Function 0.    Mouse Reset     */
int  Reset() /*ˬdƹO_w Ǧ^ 0 => w, 1 => w*/
{
  union REGS ireg, oreg;

  ireg.x.ax = 0;
  int86(0x33, &ireg, &oreg);

  return(oreg.x.ax);
}

/*-----------------------------------------------------------------*/
/*  Function 1.    Show mouse cursor   */
void Show_Mouse() /* ܷƹ */
{
  union REGS ireg;

  ireg.x.ax = 1;
  int86(0x33, &ireg, &ireg);
}

/*-----------------------------------------------------------------*/
/* Function 2.     Hide mouse cursor   */
void Hide_Mouse() /* ÷ƹ */
{
  union REGS ireg;

  ireg.x.ax = 2;
  int86(0x33, &ireg, &ireg);
}

/*-----------------------------------------------------------------*/
/* Function 3. Check if left button is pressed.   */
int  Left_Pressed() /* O_Q */
{
  union REGS ireg, oreg;

  ireg.x.ax = 3;
  int86(0x33, &ireg, &oreg);
  return (oreg.x.bx & 0x01);
}

/*-----------------------------------------------------------------*/
/* Function 3.   Get position of cursor   */
void Get_XY(int *x, int *y) /* Ūƹ x , y y */
{
  union REGS ireg, oreg;

  ireg.x.ax = 3;
  int86(0x33, &ireg, &oreg);

  *x = oreg.x.cx;
  *y = oreg.x.dx;
}

/*-----------------------------------------------------------------*/
/* Function 7.  Set the range of horizontal
                cursor position               */
void Set_X_Range(int min, int max) /* ]wƹүಾ X bd */
{
   union REGS ireg;

   ireg.x.ax = 7;
   ireg.x.cx = min;
   ireg.x.dx = max;
   int86(0x33, &ireg, &ireg);
}

/*-----------------------------------------------------------------*/
/* Function 8.  Set the range of vertical
                cursor position               */
void Set_Y_Range(int min, int max) /* ]wƹүಾ Y bd */
{
   union REGS ireg;

   ireg.x.ax = 8;
   ireg.x.cx = min;
   ireg.x.dx = max;
   int86(0x33, &ireg, &ireg);
}

/*-----------------------------------------------------------------*/
/* Function 9.  Set graphic cursor block  */
void Set_Graphic_Cursor(int x, int y,unsigned int far *pattern)
{  /* ]wøϼҺAUƹХ~ */

   union REGS ireg;
   struct SREGS isreg;

   ireg.x.ax = 9;
   ireg.x.bx = x;
   ireg.x.cx = y;
   ireg.x.dx = FP_OFF(pattern);
   isreg.es  = FP_SEG(pattern);
   int86x(0x33, &ireg, &ireg, &isreg);
}

/*-----------------------------------------------------------------*/
void colorbar()
{
int wi,he,x,y,color;
int i,s;

wi = MaxX / 16;
he = MaxY / 12;
color = 1;

show_txt(6,1,10,"TOUCH SCREEN");

for (i=0 ; i<3 ; i++) {

    for (s=0 ; s<5 ; s++) {

      x = (s*3+1) * wi;
      y = (i*3+3) * he;

      setfillstyle(SOLID_FILL, color);
      setcolor( color );

      bar( x, y, x+(wi*2), y+(he*2) );
      rectangle( x, y, x+(wi*2), y+(he*2) );
      color++;
    }
}

  setfillstyle(SOLID_FILL, 4);
  setcolor( color );

  bar(MaxX-(wi*2), MaxY-he, MaxX, MaxY);
  show_txt(3,MaxX-(wi*2)+15,MaxY-he+5,"EXIT");

}

/*-----------------------------------------------------------------*/
void touch()
{
int wi,he,x,y,x1,y1;
int i,s,pre;
int MouseX,MouseY;

wi = MaxX / 16;
he = MaxY / 12;

while(1){

 if (Left_Pressed() == 1) {

    Get_XY(&MouseX,&MouseY);

    for (i=0 ; i<3 ; i++) {

       y  = (i*3+3) * he;
       y1 = y+(he*2);

          if ((MouseY >= y ) && (MouseY <= y1)) {

                for (s=0 ; s<5 ; s++) {

                     x  = (s*3+1) * wi;
                     x1 = x+(wi*2);

                       if ((MouseX >= x ) && (MouseX <= x1)) {
                            sound(soun[i][s]);
/*                          Hide_Mouse();*/
                            show_color(x,y,x1,y1,i*5+s+1);
/*                          Show_Mouse();*/
                            nosound();
                            break;
                       }
                }
          }
    }

    if ((MouseX >= MaxX-(wi*2)) && (MouseX <= MaxX)) { /* EXIT */
         if ((MouseY >= MaxY-he) && (MouseY <= MaxY)) {
/*            closegraph();
              exit(1);*/
              break;
         }
    }


 }

}
}

/*-----------------------------------------------------------------*/
void show_color(int x1,int y1,int x2,int y2,int color)
{
int xk,yk,k;
int i,s,ck;

ck=0;
for (s=0 ; s<20 ; s++)
{
k=1;
    for (i=s ; i>=0 ; i--)
    {

      setcolor(i%16);
      setfillstyle(1,i%16);
      setlinestyle(0,0,3);
      if (((x1+k)>(x2-k)) || ((y1+k)>(y2-k))) {
         ck = 1;
         break;
      }
      rectangle(x1+k,y1+k,x2-k,y2-k);

      k = k+2;
    }
if (ck == 1)
    break;

}

 setfillstyle(SOLID_FILL, color);
 setcolor( color );

 bar( x1, y1, x2, y2 );

}

/*-----------------------------------------------------------------*/
void show_txt(int font, int xloc, int yloc, char *fmt, ... )
{
  va_list  argptr;
  char str[140];
  int width,x1;

  va_start( argptr, format );

  vsprintf( str, fmt, argptr );
  settextstyle(1,0,font);
  width  = textwidth( str ) ;
  setcolor(15);

  if (font == 6)
      x1 = (MaxX - width) / 2;
  else
      x1 = xloc;

  outtextxy( x1, yloc, str );        /* Send string in graphics mode */

  va_end( argptr );                     /* Close va_ functions          */

}

/*-----------------------------------------------------------------*/
void Graph_Init()
{
        int Gd = DETECT, Gm;
        registerbgidriver(EGAVGA_driver);
        registerbgifont(triplex_font);

        initgraph( &Gd, &Gm, "" );

        MaxX = getmaxx();
        MaxY = getmaxy();
}
